﻿//If the SDK namespace object is not defined, create it.
if (typeof (MCS) == "undefined")
{ MCS = {}; }
// Create Namespace container for functions in this library;
MCS.mcs_Resource_Buttons = {};

MCS.mcs_Resource_Buttons.FORM_TYPE_CREATE = 1;
MCS.mcs_Resource_Buttons.FORM_TYPE_UPDATE = 2;
MCS.mcs_Resource_Buttons.FORM_TYPE_READ_ONLY = 3;
MCS.mcs_Resource_Buttons.FORM_TYPE_DISABLED = 4;


MCS.mcs_Resource_Buttons.openResourceCalendar = function() {

    var relatedSystemResource = Xrm.Page.getAttribute("mcs_relatedresourceid");
    var relatedSystemResourceId;
    var relatedSystemResourceName;

    if (relatedSystemResource != null) {
        var relatedSystemResourceValue = relatedSystemResource.getValue();
        if (relatedSystemResourceValue[0] != null) {
            relatedSystemResourceId = relatedSystemResourceValue[0].id;
           // relatedSystemResourceName = relatedSystemResourceValue[0].name;
            //   alert(relatedSystemResource + relatedSystemResourceName);
        }
    }

    Xrm.Utility.openEntityForm("equipment", relatedSystemResourceId);

}

MCS.mcs_Resource_Buttons.UpdateResourceConnections = function() {

    var updateResourceConnections = Xrm.Page.getAttribute("cvt_updateresourceconnections");

    var r = confirm("Please confirm that you would like to update this TSS Resource and all of its connections to MTSA's, TSA's, and Resource Groups. Please Select Ok to continue or Cancel to abort.");
    if (r == true) {
        x = alert("All fields on this TSS Resource all now editable (Except for Site & Type). After making changes, click Save or Save & Close to initiate process of updating all connections.")
        updateResourceConnections.setValue(true);
       // Xrm.Page.ui.controls.get("mcs_relatedsiteid").setDisabled(false);
       // Xrm.Page.ui.controls.get("mcs_type").setDisabled(false);
    }
    else {
        x = "Aborted";
        updateResourceConnections.setValue(false);
        //Xrm.Page.data.entity.save();
    }
}

MCS.mcs_Resource_Buttons.ReplaceResource = function() {

    var replaceResourceConnections = Xrm.Page.getAttribute("cvt_replaceresourceconnections");
    var EntityName = Xrm.Page.data.entity.getEntityName();
    var EntityId = Xrm.Page.data.entity.getId();

    var r = confirm("Please confirm that you would like to replace this TSS Resource on all MTSA's, TSA's, and Resource Groups. Please Select Ok to continue or Cancel to abort.");
    if (r == true) {
        x = 
        MCS.mcs_Resource_Buttons.openDialogProcess("26CDD7B6-7A94-47E2-BC3A-1169722E81F0", EntityName, EntityId)
        //The Dialog will set the update Resource Connections field to True instead. 
        //updateResourceConnections.setValue(true);
        //Xrm.Page.data.entity.save();
    }
    else {
        x = "Aborted";
        replaceResourceConnections.setValue(false);
        //Xrm.Page.data.entity.save();
    }
}

MCS.mcs_Resource_Buttons.DeleteResourceConnections = function () {

    var deleteResourceConnections = Xrm.Page.getAttribute("cvt_deleteresourceconnections");

    var r = confirm("Please confirm that you would like to remove all connections to MTSA's, TSA's, and Resource Groups for this TSS Resource. Please Select Ok to continue or Cancel to abort.");
    if (r == true) {
        x = alert("All connections to MTSA's, TSA's, and Resource Groups for this TSS Resource are being removed. You may also choose to delete this TSS Resource by selecting the delete button in ribbon.")
        deleteResourceConnections.setValue(true);
        Xrm.Page.data.entity.save();
    }
    else {
        x = "Aborted";
        deleteResourceConnections.setValue(false);
       // Xrm.Page.data.entity.save();
    }
}


MCS.mcs_Resource_Buttons.openDialogProcess = function (dialogId, EntityName, objectId) {
    var url = Xrm.Page.context.getClientUrl() +
      "/cs/dialog/rundialog.aspx?DialogId=" +
      dialogId + "&EntityName=" +
      EntityName + "&ObjectId=" +
      objectId;
    var width = 400;
    var height = 400;
    var left = (screen.width - width) / 2;
    var top = (screen.height - height) / 2;
    window.open(url, '', 'location=0,menubar=1,resizable=0,width=' + width +',height=' + height +',top=' + top +',left=' + left +'');
}


MCS.mcs_Resource_Buttons.runRibbonWorkflow = function (workflowId) {
    MCS.GlobalFunctions.runWorkflow(Xrm.Page.data.entity.getId(), workflowId, MCS.GlobalFunctions.runWorkflowResponse);
}