﻿//If the SDK namespace object is not defined, create it.
if (typeof (MCS) == "undefined")
{ MCS = {}; }
// Create Namespace container for functions in this library;
MCS.mcs_Resource_OnChange = {};

MCS.mcs_Resource_OnChange.FORM_TYPE_CREATE = 1;
MCS.mcs_Resource_OnChange.FORM_TYPE_UPDATE = 2;
MCS.mcs_Resource_OnChange.FORM_TYPE_READ_ONLY = 3;
MCS.mcs_Resource_OnChange.FORM_TYPE_DISABLED = 4;

MCS.mcs_Resource_OnChange.ResourceType = function () {
    /***********************************************************************
    /** 
    /** Description: Displays different tabs basedon the Resource Type selected. 
    /** 
    ***********************************************************************/
    //grab the control for the type field
    var resourceType = Xrm.Page.ui.controls.get("mcs_type");
    var componentType = Xrm.Page.ui.controls.get("cvt_componenttype");
    var systemType = Xrm.Page.ui.controls.get("cvt_systemtype");
    var userinput = Xrm.Page.ui.controls.get("mcs_usernameinput");
    var building = Xrm.Page.ui.controls.get("cvt_building");
    var uniqueid = Xrm.Page.ui.controls.get("cvt_uniqueid");
    var room = Xrm.Page.getAttribute("mcs_room");
    var vistalabel = Xrm.Page.getAttribute("mcs_usernameinput");
    var vistacapacity = Xrm.Page.ui.controls.get("cvt_vistacapacity");
    //grab the tab controls
    var roomTab = Xrm.Page.ui.tabs.get("tab_room_information");
    var technologyTab = Xrm.Page.ui.tabs.get("tab_technology_information");
    var vistaTab = Xrm.Page.ui.tabs.get("tab_clinic_information");
    var componentsTab = Xrm.Page.ui.tabs.get("tab_9");
   
    //check if resource type is null and then get attritbute value if not.
    if (resourceType != null) var resourceTypeValue = resourceType.getAttribute("mcs_type").getValue();
        
    if (resourceTypeValue != null) {
        //set tab visible based on dependent field's value            
        if (resourceTypeValue == 251920000) {
            vistaTab.setVisible(false);
            userinput.setVisible(true);
            userinput.setDisabled(false);
            vistalabel.setRequiredLevel(true);
            vistacapacity.setVisible(true);
        }
        else {
            vistaTab.setVisible(false);
            userinput.setVisible(false);
            userinput.setDisabled(true);
            vistacapacity.setVisible(false);
            vistalabel.setRequiredLevel(false);
        }
        if (resourceTypeValue == 251920001) {
            roomTab.setVisible(true);
            room.setRequiredLevel("required");
        }
        else {
            roomTab.setVisible(false);
            room.setRequiredLevel("none");
        }
        if (resourceTypeValue == 251920002) {
            technologyTab.setVisible(true);
            componentsTab.setVisible(true);

            Xrm.Page.getAttribute("cvt_systemtype").setRequiredLevel("required");

            if (systemType != null) var systemTypeValue = systemType.getAttribute("cvt_systemtype").getValue();
            if (systemTypeValue == 100000000) {

                Xrm.Page.getAttribute("cvt_componenttype").setRequiredLevel("required");
                componentType.setVisible(true);
            }

            else{
                Xrm.Page.getAttribute("cvt_componenttype").setRequiredLevel("none");
                Xrm.Page.getAttribute("cvt_componenttype").setValue(null);
                componentType.setVisible(false);
            }
        }
        else {
            technologyTab.setVisible(false);
            componentsTab.setVisible(false);
            Xrm.Page.getAttribute("cvt_systemindex").setRequiredLevel("none");
            Xrm.Page.getAttribute("cvt_systemtype").setRequiredLevel("none");
        }
    }
    else {
        userinput.setVisible(false);
        vistaTab.setVisible(false);
        roomTab.setVisible(false);
        technologyTab.setVisible(false);
        Xrm.Page.getAttribute("cvt_systemindex").setRequiredLevel("none");
        Xrm.Page.getAttribute("cvt_systemtype").setRequiredLevel("none");
    }

    //Prepopulate for CVT Patient Tablet
    if (Xrm.Page.getAttribute("cvt_systemtype").getValue() == 917290005) {
        if (Xrm.Page.getAttribute("cvt_primaryusertype").getValue() != null) {
            Xrm.Page.getAttribute("cvt_primaryusertype").setValue(917290000);
        }

        if (Xrm.Page.getAttribute("cvt_locationuse").getValue() != null) {
            Xrm.Page.getAttribute("cvt_locationuse").setValue(917290001);
        }

        Xrm.Page.getAttribute("cvt_room").setValue("");
        Xrm.Page.getControl("cvt_room").setDisabled(true);
        Xrm.Page.getAttribute("cvt_room").setSubmitMode("always");
    }
    else {
        Xrm.Page.getControl("cvt_room").setDisabled(false);
    }

};


MCS.mcs_Resource_OnChange.CheckCapacity = function () {
    /****************************************
    /**
    /** Description: Check's Capacity Value
    /**
    /**
    ****************************************/

    var CapacityValue = Xrm.Page.getAttribute("cvt_capacity").getValue();
    if (CapacityValue == 0) {
        alert("Capacity must be greater than 0");
        Xrm.Page.data.entity.attributes.get("cvt_capacity").setValue(CachedCapacityValue);
    }
};
