﻿//If the SDK namespace object is not defined, create it.
if (typeof (MCS) == "undefined")
{ MCS = {}; }
// Create Namespace container for functions in this library;
MCS.mcs_Resource = {};

MCS.mcs_Resource.FORM_TYPE_CREATE = 1;
MCS.mcs_Resource.FORM_TYPE_UPDATE = 2;
MCS.mcs_Resource.FORM_TYPE_READ_ONLY = 3;
MCS.mcs_Resource.FORM_TYPE_DISABLED = 4;

MCS.mcs_Resource.CreateName = function () {
    /***********************************************************************
    /** Description: CreateName
    ***********************************************************************/
    var resourceType = Xrm.Page.getAttribute("mcs_type").getValue();
    var mcs_usernameinput = Xrm.Page.getAttribute("mcs_usernameinput").getValue();
    var mcs_relatedsiteid = Xrm.Page.getAttribute("mcs_relatedsiteid").getValue();   
    var componentType = Xrm.Page.getAttribute("cvt_componenttype").getValue();
    var systemType = Xrm.Page.getAttribute("cvt_systemtype").getValue();
    var building = Xrm.Page.getAttribute("cvt_building").getValue();
    var room = Xrm.Page.getAttribute("mcs_room").getValue();
    var uniqueid = Xrm.Page.getAttribute("cvt_uniqueid").getValue();    
    var derivedResultField = "";

    if (resourceType == 251920001) {
        if (building != null)
            derivedResultField = "Bldg. " + building;

        if (room != null)
            derivedResultField = "Room " + room;

        if ((building != null) && (room != null))
            derivedResultField = "Bldg. " + building + ", Room " + room;

        if ((building == null) && (room == null) && (mcs_usernameinput != null) )
            derivedResultField += mcs_usernameinput
    }

    if (resourceType == 251920002) {
        if (systemType != null) {
            derivedResultField = Xrm.Page.getAttribute("cvt_systemtype").getText();
            if (uniqueid != null) 
                derivedResultField += ": " + uniqueid;
        }

        if (componentType != null) {
            derivedResultField = Xrm.Page.getAttribute("cvt_componenttype").getText();
            if (uniqueid != null) 
                derivedResultField += ": " + uniqueid;       
        }
    }

    if ((resourceType != 251920002) && (resourceType != 251920001)) {
        if (mcs_usernameinput != null)
            derivedResultField = mcs_usernameinput;
     
    }

    derivedResultField += " @ ";
    if (mcs_relatedsiteid != null)
        derivedResultField += mcs_relatedsiteid[0].name;


    Xrm.Page.getAttribute("mcs_name").setSubmitMode("always");
    Xrm.Page.getAttribute("mcs_name").setValue(derivedResultField);
};

MCS.mcs_Resource.MakeFieldsReadOnly = function () {
    /***********************************************************************
    /** 
    /** Description: MakeFieldsReadOnly
    /** 
    ***********************************************************************/
    var Formtype = Xrm.Page.ui.getFormType();
    var resourceType = Xrm.Page.getAttribute("mcs_type").getValue();

    if (Formtype != MCS.mcs_Resource.FORM_TYPE_CREATE) {
        Xrm.Page.ui.controls.get("mcs_type").setDisabled(true);
        if (Xrm.Page.getAttribute("mcs_type").getValue() != 251920002)
            Xrm.Page.ui.controls.get("mcs_relatedsiteid").setDisabled(true);
    }
};

MCS.mcs_Resource.SubmitFields = function () {
    Xrm.Page.getAttribute("mcs_name").setSubmitMode("always");
    Xrm.Page.getAttribute("cvt_updateresourceconnections").setSubmitMode("always");
    Xrm.Page.getAttribute("cvt_replaceresourceconnections").setSubmitMode("always");
    Xrm.Page.getAttribute("cvt_deleteresourceconnections").setSubmitMode("always");
    Xrm.Page.getAttribute("cvt_replacementresource").setSubmitMode("always");
};