﻿//If the SDK namespace object is not defined, create it.
if (typeof (MCS) == "undefined")
{ MCS = {}; }
// Create Namespace container for functions in this library;
MCS.mcs_Resource_OnLoad = {};

MCS.mcs_Resource_OnLoad.FORM_TYPE_CREATE = 1;
MCS.mcs_Resource_OnLoad.FORM_TYPE_UPDATE = 2;
MCS.mcs_Resource_OnLoad.FORM_TYPE_READ_ONLY = 3;
MCS.mcs_Resource_OnLoad.FORM_TYPE_DISABLED = 4;

//Namespace Variables
var CachedCapacityValue = null;
var CachedVistaCapacityValue = null;

MCS.mcs_Resource_OnLoad.RemoveProTeleOptions = function() {
    /***********************************************************************
    /** Description: Removes the Provider and Telepresenter options from the Option Set. 
    ***********************************************************************/
    
    //Validate what the type is -if from TSS Resource Group
    if (Xrm.Page.getAttribute("mcs_resourcegroupguid").getValue() != null) {
        switch (Xrm.Page.getAttribute("mcs_type").getValue()) {
            case 99999999: //Provider
                MCS.cvt_Common.closeWindow("A Provider cannot be added this way. Contact your administrator for questions.");
                break;
            case 100000000:
            case 99999999: //Provider
            case 917290000: 
                Xrm.Page.getAttribute("mcs_type").setValue(null)              
                break;
        }
    }
    var options = Xrm.Page.ui.controls.get("mcs_type");
    options.removeOption(100000000);
    options.removeOption(99999999);
    options.removeOption(917290000);
    
    //After removing options, if it still exists, lock it in.
    if (Xrm.Page.getAttribute("mcs_type").getValue() != null) {
        Xrm.Page.getAttribute("mcs_type").setSubmitMode(true);
        Xrm.Page.getControl("mcs_type").setDisabled(true);
    }
};

MCS.mcs_Resource_OnLoad.SetDefaultCapacity = function () {
    /****************************************
    /** Description: Check's Capacity Value
    ****************************************/
    var VistaCapacityValue = Xrm.Page.getAttribute("cvt_vistacapacity").getValue();
    var CapacityValue = Xrm.Page.getAttribute("cvt_capacity").getValue();
    var resourceType = Xrm.Page.ui.controls.get("mcs_type");
    //check if resource type is null and then get attritbute value if not.
    if (resourceType != null) var resourceTypeValue = resourceType.getAttribute("mcs_type").getValue();

    if (resourceTypeValue == 251920001) {
        if (CapacityValue == null) {
            Xrm.Page.getAttribute("cvt_capacity").setValue(1);
            Xrm.Page.getAttribute("cvt_capacity").setSubmitMode("always");
        }
        CachedCapacityValue = Xrm.Page.getAttribute("cvt_capacity").getValue();
    }

    if (resourceTypeValue == 251920000) {
        if (VistaCapacityValue == null) {
            Xrm.Page.getAttribute("cvt_vistacapacity").setValue(1);
            Xrm.Page.getAttribute("cvt_vistacapacity").setSubmitMode("always");
        }
        CachedVistaCapacityValue = Xrm.Page.getAttribute("cvt_vistacapacity").getValue();
    }
};


MCS.mcs_Resource_OnLoad.GetRelatedTSAs = function () {
    var FormType = Xrm.Page.ui.getFormType();
    if (FormType != 1) {
        var TSAProvGrid = document.getElementById("RelatedTSAsProvSite"); //grid to filter 
        var TSAPatGrid = document.getElementById("RelatedTSAsPatSite"); //grid to filter 
        if (TSAProvGrid == null || TSAPatGrid == null) { //make sure the grids have loaded 
            setTimeout(function () { MCS.mcs_Resource_OnLoad.GetRelatedTSAs(); }, 500); //if the grid hasn’t loaded run this again when it has 
            return;
        }

        var ThisResourceValue = Xrm.Page.data.entity.getId();; //field to filter by
        var ThisResourceName = Xrm.Page.getAttribute("mcs_name").getValue();

        var ResourceId = "00000000-0000-0000-0000-000000000000"; //if filter field is null display nothing 
        if (ThisResourceValue != null) {
            var ResourceId = ThisResourceValue;
        }

        //fetch xml code which will retrieve all TSA's Related to this Resource.  
        var fetchXmlTSAProv =

        "<fetch version='1.0' output-format='xml-platform' mapping='logical' distinct='true'>" +
        "<entity name='mcs_services'>" +
        "<attribute name='mcs_name' />" +
        "<attribute name='createdon' />" +
        "<attribute name='cvt_relatedprovidersiteid' />" +
        "<attribute name='cvt_relatedpatientsiteid' />" +
        "<attribute name='cvt_relatedmasterid' />" +
        "<attribute name='cvt_servicetype' />" +
        "<attribute name='cvt_servicesubtype' />" +
        "<attribute name='statuscode' />" +
        "<attribute name='ownerid' />" +
        "<attribute name='modifiedon' />" +
        "<attribute name='cvt_servicescope' />" +
        "<attribute name='cvt_groupappointment' />" +
        "<attribute name='cvt_provsitevistaclinics' />" +
        "<attribute name='cvt_patsitevistaclinics' />" +
        "<attribute name='mcs_servicesid' />" +
        "<order attribute='mcs_name' descending='false' />" +
        "<filter type='and'>" +
        "<condition attribute='statecode' operator='eq' value='0' />"+
        "</filter>" +
        "<link-entity name='cvt_providerresourcegroup' from='cvt_relatedtsaid' to='mcs_servicesid' alias='ai'>" +
        "<filter type='and'>" +
        "<condition attribute='cvt_relatedresourceid' operator='eq' uiname='" + MCS.cvt_Common.formatXML(ThisResourceName) + "' uitype='mcs_resource' value='" + ResourceId + "' />" +
        "</filter>" +
        "</link-entity>" +
        "</entity>" +
        "</fetch>";

        var fetchXmlTSAPat =

        "<fetch version='1.0' output-format='xml-platform' mapping='logical' distinct='true'>" +
        "<entity name='mcs_services'>" +
        "<attribute name='mcs_name' />" +
        "<attribute name='createdon' />" +
        "<attribute name='cvt_relatedprovidersiteid' />" +
        "<attribute name='cvt_relatedpatientsiteid' />" +
        "<attribute name='cvt_relatedmasterid' />" +
        "<attribute name='cvt_servicetype' />" +
        "<attribute name='cvt_servicesubtype' />" +
        "<attribute name='statuscode' />" +
        "<attribute name='ownerid' />" +
        "<attribute name='modifiedon' />" +
        "<attribute name='cvt_servicescope' />" +
        "<attribute name='cvt_groupappointment' />" +
        "<attribute name='cvt_provsitevistaclinics' />" +
        "<attribute name='cvt_patsitevistaclinics' />" +
        "<attribute name='mcs_servicesid' />" +
        "<order attribute='mcs_name' descending='false' />" +
        "<filter type='and'>" +
        "<condition attribute='statecode' operator='eq' value='0' />" +
        "</filter>" +
        "<link-entity name='cvt_patientresourcegroup' from='cvt_relatedtsaid' to='mcs_servicesid' alias='ai'>" +
        "<filter type='and'>" +
        "<condition attribute='cvt_relatedresourceid' operator='eq' uiname='" + MCS.cvt_Common.formatXML(ThisResourceName) + "' uitype='mcs_resource' value='" + ResourceId + "' />" +
        "</filter>" +
        "</link-entity>" +
        "</entity>" +
        "</fetch>";

        TSAProvGrid.control.SetParameter("fetchXml", fetchXmlTSAProv); //set the fetch xml to the sub grid   
        TSAProvGrid.control.Refresh(); //refresh the sub grid using the new fetch xml

        TSAPatGrid.control.SetParameter("fetchXml", fetchXmlTSAPat); //set the fetch xml to the sub grid   
        TSAPatGrid.control.Refresh(); //refresh the sub grid using the new fetch xml
    }
};

MCS.mcs_Resource_OnLoad.GetRelatedServiceActivities = function () {

    var FormType = Xrm.Page.ui.getFormType();
    if (FormType != 1) {

        var SAGrid = document.getElementById("RelatedServiceActivities"); //grid to filter 

        if (SAGrid == null) { //make sure the grids have loaded 
            setTimeout(function () { MCS.mcs_Resource_OnLoad.GetRelatedServiceActivities(); }, 500); //if the grid hasn’t loaded run this again when it has 
            return;
        }

        var ThisResourceId = "00000000-0000-0000-0000-000000000000"; //if filter field is null display nothing
        var ThisResourceName = '';
        var ThisResource = Xrm.Page.getAttribute("mcs_relatedresourceid").getValue(); //field to filter by
        if (ThisResource != null)
        {
            ThisResourceId = ThisResource[0].id;
            ThisResourceName = ThisResource[0].name;
        }
      
        //fetch xml code which will retrieve all TSA's Related to this Resource.  
        var fetchXmlServiceActivities =

        "<fetch version='1.0' output-format='xml-platform' mapping='logical' distinct='true'>" +
        "<entity name='activitypointer'>" +
        "<attribute name='activitytypecode' />"+
        "<attribute name='subject' />"+
        "<attribute name='statecode' />"+
        "<attribute name='prioritycode' />"+
        "<attribute name='modifiedon' />"+
        "<attribute name='activityid' />"+
        "<attribute name='instancetypecode' />"+
        "<order attribute='modifiedon' descending='false' />"+
        "<filter type='and'>" +
        "<condition attribute='activitytypecode' operator='eq' value='4214' />"+
        "<condition attribute='scheduledstart' operator='next-x-weeks' value='6' />"+
        "</filter>"+
        "<link-entity name='activityparty' from='activityid' to='activityid' alias='al'>"+
        "<filter type='and'>"+
        "<condition attribute='partyid' operator='eq' uiname='" + MCS.cvt_Common.formatXML(ThisResourceName) + "' uitype='equipment' value='" + ThisResourceId + "' />" +
        "</filter>"+
        "</link-entity>"+
        "</entity>"+
        "</fetch>";

        SAGrid.control.SetParameter("fetchXml", fetchXmlServiceActivities); //set the fetch xml to the sub grid   
        SAGrid.control.Refresh(); //refresh the sub grid using the new fetch xml    
    }
};